﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Newtonsoft.Json;
using Syncfusion.EJ2.Base;

namespace Razorpages.Pages
{
    public class IndexModel : PageModel
    {
        public System.Collections.Generic.List<DropDownData> DropDatasource { get; set; }
        public static List<DropDownData> dropdown = new List<DropDownData>();
        public void OnGet()
        {
            DropDatasource = DropDownData.GetDropData().ToList();
        }

        public class DropDownData
        {
            public static List<DropDownData> dropdata = new List<DropDownData>();
            public int CustomerID { get; set; }
            public string OptionText { get; set; }
            public DropDownData()
            {

            }
            public DropDownData(int id, string name)
            {
                this.CustomerID = id;
                this.OptionText = name;
            }

            public static List<DropDownData> GetDropData()
            {
                if (dropdata.Count() == 0)
                {
                    dropdata.Add(new DropDownData(1, "Reims"));
                    dropdata.Add(new DropDownData(2, "Münster"));
                    dropdata.Add(new DropDownData(3, "Rio"));
                    dropdata.Add(new DropDownData(4, "Lyon"));
                    dropdata.Add(new DropDownData(5, "Resende"));
                    dropdata.Add(new DropDownData(6, "Graz"));
                    dropdata.Add(new DropDownData(7, "México"));
                    dropdata.Add(new DropDownData(8, "Oulu"));
                }
                return dropdata;

            }
        }
        public class Data
        {

            public bool requiresCounts { get; set; }
            public int skip { get; set; }

            public int EmployeeID { get; set; }
            public int EmployeeName { get; set; }
            public int take { get; set; }
        }

        public class AutoCompleteDM
        {
            public bool requiresCounts { get; set; }

            public int take { get; set; }
            public List<Wheres> where { get; set; }

        }

        public class Wheres
        {
            public string field { get; set; }
            public bool ignoreAccent { get; set; }

            public bool ignoreCase { get; set; }

            public bool isComplex { get; set; }

            public string value { get; set; }
            public string Operator { get; set; }

        }



        public JsonResult OnPostAutoCompleteDataSource([FromBody]AutoCompleteDM dm)
        {
            var data = Employee1Details.GetAllRecords().ToList();
            int count = data.Cast<Employee1Details>().Count();
            if (dm.where != null)
            {
                data = (from cust in data
                        where cust.FirstName.ToLower().StartsWith(dm.@where[0].value.ToString())
                        select cust).ToList();
            }
            if (dm.take != 0)
            {
                data = data.Take(dm.take).ToList();
            }
            return dm.requiresCounts ? new JsonResult(new { result = data, count = count }) : new JsonResult(data);
        }

        public JsonResult OnPostDataSource([FromBody]DataManagerRequest dm)
        {
            IEnumerable DataSource = OrdersDetails.GetAllRecords();
            DataOperations operation = new DataOperations();
            if (dm.Search != null && dm.Search.Count > 0)
            {
                DataSource = operation.PerformSearching(DataSource, dm.Search);  //Search
            }
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                DataSource = operation.PerformSorting(DataSource, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                DataSource = operation.PerformFiltering(DataSource, dm.Where, dm.Where[0].Operator);
            }
            int count = DataSource.Cast<OrdersDetails>().Count();
            if (dm.Skip != 0)
            {
                DataSource = operation.PerformSkip(DataSource, dm.Skip);   //Paging
            }
            if (dm.Take != 0)
            {
                DataSource = operation.PerformTake(DataSource, dm.Take);
            }
            return dm.RequiresCounts ? new JsonResult(new { result = DataSource, count = count }) : new JsonResult(DataSource);
    }

        public JsonResult OnPostInsert([FromBody]CRUDModel<OrdersDetails> value)
        {

            OrdersDetails.GetAllRecords().Insert(0, value.value);
            return new JsonResult(value.value);
        }

        public JsonResult OnPostUpdate([FromBody]CRUDModel<OrdersDetails> value)
        {
            var ord = value.value;
            OrdersDetails val = OrdersDetails.GetAllRecords().Where(or => or.OrderID == ord.OrderID).FirstOrDefault();
            val.OrderID = ord.OrderID;
            val.EmployeeID = ord.EmployeeID;
            val.CustomerID = ord.CustomerID;
            val.CustomerName = ord.CustomerName;
            val.City = ord.City;

            return new JsonResult(value.value);
        }


        public JsonResult OnPostDelete([FromBody]CRUDModel<OrdersDetails> value)
        {
            //OrdersDetails.GetAllRecords().Remove(OrdersDetails.GetAllRecords().Where(or => or.OrderID == int.Parse(value.key.ToString())).FirstOrDefault());
            return new JsonResult(value);
        }

        public class DataC
        {

            public bool requiresCounts { get; set; }
            public int skip { get; set; }

            public int EmployeeID { get; set; }
            public int FirstName { get; set; }
            public int take { get; set; }
        }

        public JsonResult OnPostUrlDatasource([FromBody]DataManagerRequest dm)
        {
            //var val = OrdersDetails.GetAllRecords();
            var val = Employee1Details.GetAllRecords();
            var Data = val.ToList();
            var count = val.Count();
            if (dm.Where != null)
            {
                Data = (from cust in Data
                        where cust.FirstName.ToLower().StartsWith(dm.Where[0].value.ToString())
                        select cust).ToList();
            }
            if (dm.Take != 0)
                Data = Data.Take(dm.Take).ToList();
            return new JsonResult(Data);
        }

        public JsonResult OnPostChildDataSource([FromBody]DataManagerRequest dm)
        {
            IEnumerable data = Employee1Details.GetAllRecords();

            DataOperations operation = new DataOperations();

            int count = data.Cast<Employee1Details>().Count();

            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                data = operation.PerformFiltering(data, dm.Where, dm.Where[0].Operator);
            }
            return dm.RequiresCounts ? new JsonResult(new { result = data, count = count }) : new JsonResult(data);


        }

        public JsonResult OnPostChildInsert([FromBody]CRUDModel<Employee1Details> value)
        {

            Employee1Details.GetAllRecords().Insert(0, value.value);
            return new JsonResult(value.value);
        }

        public JsonResult OnPostChildUpdate([FromBody]CRUDModel<Employee1Details> value)
        {
            var ord = value.value;
            Employee1Details val = Employee1Details.GetAllRecords().Where(or => or.EmployeeID == ord.EmployeeID).FirstOrDefault();
            val.EmployeeID = ord.EmployeeID;
            val.FirstName = ord.FirstName;
            val.LastName = ord.LastName;
            val.ReportsTo = ord.ReportsTo;

            return new JsonResult(value.value);
        }


        public JsonResult OnPostChildDelete([FromBody]CRUDModel<Employee1Details> value)
        {
            Employee1Details.GetAllRecords().Remove(Employee1Details.GetAllRecords().Where(or => or.EmployeeID == int.Parse(value.key.ToString())).FirstOrDefault());
            return new JsonResult(value);
        }

        public class CRUDModel<T> where T : class
        {
            public string action { get; set; }

            public string table { get; set; }

            public string keyColumn { get; set; }

            public object key { get; set; }

            public T value { get; set; }

            public List<T> added { get; set; }

            public List<T> changed { get; set; }

            public List<T> deleted { get; set; }

            public IDictionary<string, object> @params { get; set; }
        }

      

        public class OrdersDetails
        {
            public static List<OrdersDetails> order = new List<OrdersDetails>();
            public OrdersDetails()
            {

            }
            public OrdersDetails(int OrderID, int CustomerID, int EmployeeID, string CustomerName, string City, DateTime? OrderDate)
            {
                this.OrderID = OrderID;
                this.CustomerID = CustomerID;
                this.EmployeeID = EmployeeID;
                this.CustomerName = CustomerName;
                this.OrderDate = OrderDate;
                this.City = City;
            }
            public static List<OrdersDetails> GetAllRecords()
            {
                if (order.Count() == 0)
                {
                    order.Add(new OrdersDetails(10248, 1, 1, "VINET", "Reims", new DateTime(1991, 05, 15)));
                    order.Add(new OrdersDetails(10249, 2, 2, "ALFKI", "Münster", null));
                    order.Add(new OrdersDetails(10250, 3, 3, "TOMSP", "Rio", null));
                    order.Add(new OrdersDetails(10251, 4, 4, "HANAR", "Lyon", new DateTime(1991, 05, 15)));
                    order.Add(new OrdersDetails(10252, 5, 5, "HILAA", "Resende", new DateTime(1991, 05, 15)));
                    order.Add(new OrdersDetails(10253, 6, 6, "CENTC", "Graz", null));
                    order.Add(new OrdersDetails(10254, 7, 7, "RICSU", "México", new DateTime(1991, 05, 15)));
                    order.Add(new OrdersDetails(10255, 8, 8, "ERNSH", "Oulu", new DateTime(1991, 05, 15)));     
                }
                return order;

            }

            public int OrderID { get; set; }
            public int CustomerID { get; set; }
            public int EmployeeID { get; set; }
            public string CustomerName { get; set; }
            public DateTime? OrderDate { get; set; }
            public string City { get; set; }
        }

        public class Employee1Details
        {
            public static List<Employee1Details> order = new List<Employee1Details>();
            public Employee1Details()
            {

            }
            public Employee1Details(int EmployeeId, string FirstName, string LastName, int ReportsTO)
            {
                this.EmployeeID = EmployeeId;
                this.FirstName = FirstName;
                this.LastName = LastName;
                this.ReportsTo = ReportsTo;
            }
            public static List<Employee1Details> GetAllRecords()
            {
                if (order.Count() == 0)
                {
                    for (int i = 1; i < 2; i++)
                    {
                        order.Add(new Employee1Details(i + 0, "Nancy", "Davolio", i + 0));
                        order.Add(new Employee1Details(i + 1, "Andrew", "Fuller", i + 3));
                        order.Add(new Employee1Details(i + 2, "Janet", "Leverling", i + 2));
                        order.Add(new Employee1Details(i + 3, "Margaret", "Peacock", i + 1));
                        order.Add(new Employee1Details(i + 0, "Jadav", "Davolio", i + 0));
                        order.Add(new Employee1Details(i + 1, "Dhoni", "Fuller", i + 3));
                        order.Add(new Employee1Details(i + 2, "Butler", "Leverling", i + 2));
                        order.Add(new Employee1Details(i + 3, "Smith", "Peacock", i + 1));

                    }
                }
                return order;
            }


            public int? EmployeeID { get; set; }
            public string FirstName { get; set; }
            public string LastName { get; set; }
            public int? ReportsTo { get; set; }
            public string key { get; set; }
        }
        public ActionResult OnPostSend()
        {
            string sPostValue1 = "";
            string sPostValue2 = "";
            string sPostValue3 = "";
            {
                MemoryStream stream = new MemoryStream();
                Request.Body.CopyTo(stream);
                stream.Position = 0;
                using (StreamReader reader = new StreamReader(stream))
                {
                    string requestBody = reader.ReadToEnd();
                    if (requestBody.Length > 0)
                    {
                        var obj = JsonConvert.DeserializeObject<PostData>(requestBody);
                        if (obj != null)
                        {
                            sPostValue1 = obj.Item1;
                            sPostValue2 = obj.Item2;
                            sPostValue3 = obj.Item3;
                        }
                    }
                }
            }
            List<string> lstString = new List<string>
            {
                sPostValue1,
                sPostValue2,
                sPostValue3
            };
            return new JsonResult(lstString);
        }
    }

    public class PostData
    {
        public string Item1 { get; set; }
        public string Item2 { get; set; }
        public string Item3 { get; set; }
    }
}

